## onednn 2.2.2+ds

=== debian/changelog ===
onednn (2.2.2+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Mo Zhou <lumin@debian.org>  Fri, 03 Sep 2021 23:22:57 -0400

onednn (2.2.2+ds-1) experimental; urgency=medium

  [ Michael R. Crusoe ]
  * debian/control: mark the -doc package as Multi-Arch: foreign

  [ Mo Zhou ]
  * New upstream version 2.2.2+ds
  * Refresh symbols control file.
  * Remove cmake-no-install-ocl-cmake.patch, no longer needed.

 -- Mo Zhou <lumin@debian.org>  Wed, 19 May 2021 14:33:32 +0800
