=== debian/changelog ===
onednn (2.2.4+ds-2) unstable; urgency=medium

  * Really fix arm64 build. The previous fix was incorrect.

 -- Mo Zhou <lumin@debian.org>  Sun, 09 Jan 2022 21:50:06 -0500

onednn (2.2.4+ds-1) unstable; urgency=medium

  [ Gard Spreemann ]
  * Update GCC 11 patch for arm64 (Closes: #984270)

  [ Mo Zhou ]
  * New upstream version 2.2.4+ds
  * Rebase existing patches.

 -- Mo Zhou <lumin@debian.org>  Mon, 03 Jan 2022 12:31:14 -0500

onednn (2.2.2+ds-3) unstable; urgency=medium

  * Team upload

  [ Gard Spreemann ]
  * Add patch to fix building with GCC 11. (Closes: #984270)

  [ Andreas Tille ]
  * Standards-Version: 4.6.0
  * Update symbols file

 -- Andreas Tille <tille@debian.org>  Tue, 23 Nov 2021 15:11:48 +0100
