=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                ninja-build,
                ocl-icd-opencl-dev,
                libsimde-dev (>= 0.7.0)
-Standards-Version: 4.5.1
+Standards-Version: 4.6.0
 Homepage: https://github.com/oneapi-src/oneDNN
 Rules-Requires-Root: no
 Vcs-Browser: https://salsa.debian.org/deeplearning-team/onednn
